#rpm 4.8.1 for PCLinuxOS 2011


%define lib64arches	x86_64 ppc64 sparc64

%ifarch %lib64arches
    %define _lib lib64
%else
    %define _lib lib
%endif

%define _prefix /usr
%define _libdir %_prefix/%_lib
%define _bindir %_prefix/bin
%define _sysconfdir /etc
%define _datadir /usr/share
%define _defaultdocdir %_datadir/doc
%define _localstatedir /var
%define _infodir %_datadir/info

%if %{?apply_patches:0}%{?!apply_patches:1}
%define apply_patches %(for p in `grep '^Patch.*:' "%{_specdir}/pclos-rpm.spec" | cut -d':' -f2-`; do echo "patch -p1 -F0 -i %{_sourcedir}/$p"; done )
%endif

%define rpmdir %{_prefix}/lib/rpm

%if %{?mklibname:0}%{?!mklibname:1}
%define mklibname(ds)  %{_lib}%{1}%{?2:%{2}}%{?3:_%{3}}%{-s:-static}%{-d:-devel}
%endif

%if %{?distsuffix:0}%{?!distsuffix:1}
%define distsuffix pclos
%endif

%if %{?mkrel:0}%{?!mkrel:1}
%define mkrel(c:) %{-c: 0.%{-c*}.}%{1}%{?distsuffix:%distsuffix}%{?!distsuffix:pclos}%{?pclinuxos_release:%pclinuxos_release}%{?subrel:.%subrel}
%endif

%if %{?mips:0}%{?!mips:1}
%define mips		mips mipsel mips32 mips32el mips64 mips64el
%endif

%if %{?pyver:0}%{?!pyver:1}
%define pyver %(python -V 2>&1 | cut -f2 -d" " | cut -f1,2 -d".")
%endif

%define __find_requires %{rpmdir}/mandriva/find-requires %{?buildroot:%{buildroot}} %{?_target_cpu:%{_target_cpu}}
%define __find_provides %{rpmdir}/mandriva/find-provides
%define _requires_exceptions libbz2.so.1

%define rpmversion	4.8.1
%define srcver		%rpmversion
%define libver		4.8
%define libmajor	1
%define release		%mkrel 10
%define librpmname   	%mklibname rpm  %{libmajor}
%define librpmnamedevel %mklibname -d rpm

%define buildpython 1

%define rpmsetup_version 1.34

%{?_with_python:%define buildpython 1}
%{?_without_python:%define buildpython 0}

Summary:	The RPM package management system
Name:		rpm
Version:	%{rpmversion}
Release:	%{release}
Group:		System/Configuration/Packaging
Source:		http://www.rpm.org/releases/rpm-%{libver}.x/rpm-%{srcver}.tar.bz2
Source1:	macros
#--------------------------------------------------------------------------------------
Patch22:    rpm-4.6.0-rc1-non-pre-scripts-dont-fail.patch
Patch31:	rpm-4.8.1-syslog.patch
Patch49:	rpm-4.6.0-rc1-provides-obsoleted.patch
Patch64:    rpm-4.6.1-rambo-rpmrc-rpmpopt.patch
Patch70:	rpm-4.6.0-rc1-bb-shortcircuit.patch
Patch83: 	rpm-4.6.0-no-doc-conflicts.patch
Patch84: 	rpm-4.4.2.2-rpmqv-ghost.patch
Patch111: 	rpm-check-file-trim-double-slash-in-buildroot.patch
Patch114: 	rpm-4.6.0-rc1-read-macros_d-dot-macros.patch
Patch133: 	rpm-4.6.0-rc1-weakdeps.patch
Patch135: 	rpm-4.4.2.3-rc1-fix-debugedit.patch
Patch137: 	rpm-4.6.0-rc1-headerIconv.patch
Patch145: 	rpm-forbid-badly-commented-define-in-spec.patch
Patch146: 	rpm-4.6.0-rc1-filetriggers.patch
Patch147: 	rpm-rpmbuild-check-useless-tags-in-non-existant-binary-packages.patch
Patch151: 	rpm-4.6.0-rc1-protect-against-non-robust-futex.patch
Patch152: 	rpm-4.6.0-rc1-fix-nss-detection.patch
Patch157: 	introduce-_after_setup-which-is-called-after-setup.patch
Patch158: 	introduce-_patch-and-allow-easy-override-when-the-p.patch
Patch159: 	introduce-apply_patches-and-lua-var-patches_num.patch
Patch1005: 	rpm-allow-conflicting-ghost-files.patch
Patch1007: 	rpm-4.6.0-rc3-xz-support.patch
Patch1008: 	rpm-4.6.0-rc3-no_rm_-rf_DOCDIR.patch
Patch1009: 	rpm-4.6.0-rpm5-tags.patch
Patch1018: 	rpm-4.8.1-setup-rubygems.patch
Patch2003: 	rpm-4.4.2.3-rc1-transmeta-crusoe-is-686.patch
Patch2005: 	rpm-4.6.0-rc1-buildlang.patch
Patch2000: 	rpm-4.6.0-rc1-serial-tag.patch
Patch2001: 	rpm-4.6.0-rc1-copyright-tag.patch
Patch3000: 	mips_macros.patch
Patch3001: 	fix_stack_protector_check.patch
Patch3002: 	mips_define_isa_macros.patch
Patch3003: 	rpm_arm_mips_isa_macros.patch
Patch3004: 	rpm_add_armv5tl.patch
# CVE Patches
Patch4000: rpm-4.8.1-CVE-2011-3378-1.patch
Patch4001: rpm-4.8.1-CVE-2011-3378-2.patch
Patch4002: rpm-4.8.1-CVE-2011-3378-3.patch
#--------------------------------------------------------------------------------------
License:	GPL
BuildRequires:	autoconf >= 2.57
BuildRequires:	zlib-devel
BuildRequires:  bzip2-devel
BuildRequires:	liblzma-devel
BuildRequires:	automake >= 1.8
BuildRequires:	elfutils-devel
BuildRequires:	sed >= 4.0.3
BuildRequires:	libbeecrypt-devel
BuildRequires:	ed, gettext-devel
BuildRequires:  libsqlite3-devel
BuildRequires:  db4.8-devel
BuildRequires:  neon-devel
BuildRequires:	popt-devel
BuildRequires:	nss-devel
BuildRequires:	magic-devel
BuildRequires:  readline-devel
BuildRequires:	ncurses-devel
BuildRequires:  openssl-devel >= 0.9.8
BuildRequires:  lua-devel
BuildRequires:	texlive
BuildRequires:	perl-File-Slurp
BuildRequires:	perl-List-MoreUtils
%if %buildpython
BuildRequires:	python-devel
%endif
Requires:	bzip2
Requires:	lzma
Requires:	cpio
Requires:	gawk
Requires:	glibc
Requires:	mktemp
Requires:	setup
Requires:	rpm-rambo-setup
Requires:	rpm-pclinuxos-setup
Requires:	update-alternatives
Requires:	%librpmname = %version-%release
URL:            http://rpm.org/
%define         git_url        http://rpm.org/git/rpm.git
Requires(pre):		rpm-helper
Requires(pre):		coreutils
Requires(postun):	rpm-helper
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
RPM is a powerful command line driven package management system capable of
installing, uninstalling, verifying, querying, and updating software packages.
Each software package consists of an archive of files along with information
about the package like its version, a description, etc.

%package -n %librpmname
Summary:  Library used by rpm
Group:	  System/Libraries
Provides: librpm = %version-%release
#Not yet 
#Obsoletes: librpm4.4 < %version-%release

%description -n %librpmname
RPM is a powerful command line driven package management system capable of
installing, uninstalling, verifying, querying, and updating software packages.
This package contains common files to all applications based on rpm.

%package -n %librpmnamedevel
Summary:	Development files for applications which will manipulate RPM packages
Group:		Development/Libraries
Requires:	rpm = %{version}-%{release}
Provides:	librpm-devel = %version-%release
Provides:   rpm-devel = %version-%release
Obsoletes:  rpm-devel < 4.4.1
Obsoletes:  %{_lib}rpm4.4-devel
Obsoletes:  %{_lib}rpm4.2-devel

%description -n %librpmnamedevel
This package contains the RPM C library and header files.  These
development files will simplify the process of writing programs
which manipulate RPM packages and databases and are intended to make
it easier to create graphical package managers or any other tools
that need an intimate knowledge of RPM packages in order to function.

This package should be installed if you want to develop programs that
will manipulate RPM packages and databases.

%package build
Summary:	Scripts and executable programs used to build packages
Group:		System/Configuration/Packaging
Requires:	autoconf
Requires:	automake
Requires:	file
Requires:	gcc-c++
Requires:	libtool-base
Requires:	patch
Requires:	make
Requires:	tar
Requires:	unzip
Requires:	elfutils
Requires:	rpm = %{version}-%{release}
Requires:	rpm-pclinuxos-setup-build %{?rpmsetup_version:>= %{rpmsetup_version}}

%description build
This package contains scripts and executable programs that are used to
build packages using RPM.

%if %buildpython
%package -n python-rpm
Summary:	Python bindings for apps which will manipulate RPM packages
Group:		Development/Python
Requires:	python
Requires:	rpm = %{version}
Obsoletes:  	rpm-python < %version-%release
Provides:   	rpm-python = %version-%release

%description -n python-rpm
The rpm-python package contains a module which permits applications
written in the Python programming language to use the interface
supplied by RPM (RPM Package Manager) libraries.

This package should be installed if you want to develop Python
programs that will manipulate RPM packages and databases.
%endif

%prep
%setup -q -n %name-%srcver
%apply_patches

%build
autoreconf -fi
CFLAGS="$RPM_OPT_FLAGS -fPIC" CXXFLAGS="$RPM_OPT_FLAGS -fPIC" \
    %configure \
        --enable-nls \
        --enable-python \
        --enable-sqlite3 \
        --without-javaglue \
	--with-external-db \
%if %buildpython
        --with-python=%{pyver} \
%else
        --without-python \
%endif
        --with-glob \
        --without-selinux \
        --without-apidocs 

%make

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=%buildroot install

#custom macro patch fuzz=2
install -m 0644 %SOURCE1 $RPM_BUILD_ROOT/usr/lib/rpm/macros

### fix settinsg on 32bit
%ifarch %{ix86}
sed  -i -e 's|x86_64|i586|g' $RPM_BUILD_ROOT/usr/lib/rpm/macros
%endif

mkdir -p $RPM_BUILD_ROOT/var/lib/rpm
for dbi in \
	Basenames Conflictname Dirnames Group Installtid Name Providename \
	Provideversion Removetid Requirename Requireversion Triggername \
	Packages __db.001 __db.002 __db.003 __db.004
do
    touch $RPM_BUILD_ROOT/var/lib/rpm/$dbi
done

test -d doc-copy || mkdir doc-copy
rm -rf doc-copy/*
ln -f doc/manual/* doc-copy/
rm -f doc-copy/Makefile*

mkdir -p $RPM_BUILD_ROOT/var/spool/repackage

mkdir -p %buildroot%_sysconfdir/rpm/macros.d
cat > %buildroot%_sysconfdir/rpm/macros <<EOF
# Put your own system macros here
# usually contains 

# Set this one according your locales
# %%_install_langs

EOF

# Get rid of unpackaged files
(cd $RPM_BUILD_ROOT;
  rm -rf .%{_includedir}/beecrypt/
  rm -f  .%{_libdir}/libbeecrypt.{a,la,so*}
  rm -f  .%{_libdir}/python*/site-packages/rpmmodule.{a,la}
  rm -f  .%{rpmdir}/{Specfile.pm,cpanflute2,cpanflute,sql.prov,sql.req,tcl.req}
  rm -f  .%{rpmdir}/{config.site,cross-build,rpmdiff.cgi}
  rm -f  .%{rpmdir}/trpm
  rm -f  .%{_bindir}/rpmdiff
)

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
if [ -f /var/lib/rpm/Packages -a -f /var/lib/rpm/packages.rpm ]; then
    echo "
You have both
	/var/lib/rpm/packages.rpm	db1 format installed package headers
	/var/lib/rpm/Packages		db3 format installed package headers
Please remove (or at least rename) one of those files, and re-install.
"
    exit 1
fi

/usr/share/rpm-helper/add-user rpm $1 rpm /var/lib/rpm /bin/false

rm -rf /usr/lib/rpm/*-mandrake-*

%post
# nuke __db.00? when updating to this rpm
rm -f /var/lib/rpm/__db.00?

if [ ! -e /etc/rpm/macros -a -e /etc/rpmrc -a -f %{rpmdir}/convertrpmrc.sh ] 
then
	sh %{rpmdir}/convertrpmrc.sh 2>&1 > /dev/null
fi

if [ -f /var/lib/rpm/packages.rpm ]; then
    /bin/chown rpm.rpm /var/lib/rpm/*.rpm
elif [ ! -f /var/lib/rpm/Packages ]; then
    /bin/rpm --initdb
fi

%postun
/usr/share/rpm-helper/del-user rpm $1 rpm

%post -n %librpmname
/sbin/ldconfig

%postun -n %librpmname
/sbin/ldconfig

%triggerpostun -- rpm < 4.4.2.3
if [ -f /etc/rpm/macros.cdb.rpmsave ]; then
   echo "warning: restoring /etc/rpm/macros.cdb from macros.cdb.rpmsave, please check you really need the changes"
   mv /etc/rpm/macros.cdb.rpmsave /etc/rpm/macros.cdb
fi

%define	rpmattr		%attr(0755, rpm, rpm)

%files -f %{name}.lang
%defattr(-,root,root)
%doc GROUPS CHANGES doc/manual/[a-z]*
%attr(0755,rpm,rpm) /bin/rpm
%attr(0755, rpm, rpm) %{_bindir}/rpm2cpio
%attr(0755, rpm, rpm) %{_bindir}/gendiff
%attr(0755, rpm, rpm) %{_bindir}/rpmdb
%attr(0755, rpm, rpm) %{_bindir}/rpmgraph
%attr(0755, rpm, rpm) %{_bindir}/rpmsign
%attr(0755, rpm, rpm) %{_bindir}/rpmquery
%attr(0755, rpm, rpm) %{_bindir}/rpmverify

%dir %{_localstatedir}/spool/repackage
%dir %{rpmdir}
%dir /etc/rpm
%config(noreplace) /etc/rpm/macros
%dir /etc/rpm/macros.d
%attr(0755, rpm, rpm) %{rpmdir}/config.guess
%attr(0755, rpm, rpm) %{rpmdir}/config.sub
%attr(0755, rpm, rpm) %{rpmdir}/rpmdb_*
%attr(0644, rpm, rpm) %{rpmdir}/macros
%attr(0755, rpm, rpm) %{rpmdir}/mkinstalldirs
%attr(0755, rpm, rpm) %{rpmdir}/rpm.*
%attr(0644, rpm, rpm) %{rpmdir}/rpmpopt*
%attr(0644, rpm, rpm) %{rpmdir}/rpmrc

%rpmattr	%{rpmdir}/rpm2cpio.sh
%rpmattr	%{rpmdir}/tgpg

%dir %attr(   -, rpm, rpm) %{rpmdir}/platform/
%ifarch %{ix86} x86_64
%attr(   -, rpm, rpm) %{rpmdir}/platform/i*86-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/athlon-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/pentium*-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/geode-*
%endif
%ifarch alpha
%attr(   -, rpm, rpm) %{rpmdir}/platform/alpha*
%endif
%ifarch %{sunsparc}
%attr(   -, rpm, rpm) %{rpmdir}/platform/sparc*
%endif
%ifarch ppc powerpc
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc32-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc64-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/powerpc-*
%endif
%ifarch ppc powerpc ppc64
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc*series-*
%endif
%ifarch ppc64
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc32-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/ppc64-*
%endif
%ifarch ia64
%attr(   -, rpm, rpm) %{rpmdir}/platform/ia64-*
%endif
%ifarch x86_64
%attr(   -, rpm, rpm) %{rpmdir}/platform/amd64-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/x86_64-*
%attr(   -, rpm, rpm) %{rpmdir}/platform/ia32e-*
%endif
%ifarch %arm
%attr(   -, rpm, rpm) %{rpmdir}/platform/armv*
%endif
%ifarch %mips
%attr(   -, rpm, rpm) %{rpmdir}/platform/mips*
%endif
%attr(   -, rpm, rpm) %{rpmdir}/platform/noarch*

%{_mandir}/man[18]/*.[18]*
%lang(pl) %{_mandir}/pl/man[18]/*.[18]*
%lang(ru) %{_mandir}/ru/man[18]/*.[18]*
%lang(ja) %{_mandir}/ja/man[18]/*.[18]*
%lang(sk) %{_mandir}/sk/man[18]/*.[18]*
%lang(fr) %{_mandir}/fr/man[18]/*.[18]*
%lang(ko) %{_mandir}/ko/man[18]/*.[18]*

#%config(noreplace,missingok)	/etc/cron.daily/rpm
#%config(noreplace,missingok)	/etc/logrotate.d/rpm

%attr(0755, rpm, rpm)	%dir %_localstatedir/lib/rpm

%define	rpmdbattr %attr(0644, rpm, rpm) %verify(not md5 size mtime) %ghost %config(missingok,noreplace)

%rpmdbattr	/var/lib/rpm/Basenames
%rpmdbattr	/var/lib/rpm/Conflictname
%rpmdbattr	/var/lib/rpm/__db.0*
%rpmdbattr	/var/lib/rpm/Dirnames
%rpmdbattr	/var/lib/rpm/Group
%rpmdbattr	/var/lib/rpm/Installtid
%rpmdbattr	/var/lib/rpm/Name
%rpmdbattr	/var/lib/rpm/Packages
%rpmdbattr	/var/lib/rpm/Providename
%rpmdbattr	/var/lib/rpm/Provideversion
%rpmdbattr	/var/lib/rpm/Removetid
%rpmdbattr	/var/lib/rpm/Requirename
%rpmdbattr	/var/lib/rpm/Requireversion
%rpmdbattr	/var/lib/rpm/Triggername

%files build
%defattr(-,root,root)
%doc CHANGES
%doc doc-copy/*
%rpmattr	%{_bindir}/rpmbuild
%rpmattr	%{_prefix}/lib/rpm/brp-*
%rpmattr	%{_prefix}/lib/rpm/check-files
%rpmattr	%{_prefix}/lib/rpm/debugedit
%rpmattr	%{_prefix}/lib/rpm/desktop-file.prov 
%rpmattr	%{_prefix}/lib/rpm/find-debuginfo.sh
%rpmattr	%{_prefix}/lib/rpm/find-lang.sh
%rpmattr	%{_prefix}/lib/rpm/find-provides
%rpmattr	%{_prefix}/lib/rpm/find-requires
%rpmattr	%{_prefix}/lib/rpm/fontconfig.prov
%rpmattr	%{_prefix}/lib/rpm/perldeps.pl
%rpmattr	%{_prefix}/lib/rpm/perl.prov
%rpmattr	%{_prefix}/lib/rpm/perl.req
%rpmattr	%{_prefix}/lib/rpm/check-buildroot
%rpmattr	%{_prefix}/lib/rpm/check-prereqs
%rpmattr	%{_prefix}/lib/rpm/check-rpaths
%rpmattr	%{_prefix}/lib/rpm/check-rpaths-worker
%rpmattr	%{_prefix}/lib/rpm/javadeps
%rpmattr	%{_prefix}/lib/rpm/libtooldeps.sh
%rpmattr	%{_prefix}/lib/rpm/macros.perl
%rpmattr	%{_prefix}/lib/rpm/macros.php
%rpmattr	%{_prefix}/lib/rpm/macros.python
%rpmattr	%{_prefix}/lib/rpm/mono-find-provides
%rpmattr	%{_prefix}/lib/rpm/mono-find-requires
%rpmattr	%{_prefix}/lib/rpm/ocaml-find-provides.sh
%rpmattr	%{_prefix}/lib/rpm/ocaml-find-requires.sh
%rpmattr	%{_prefix}/lib/rpm/osgideps.pl
%rpmattr	%{_prefix}/lib/rpm/pkgconfigdeps.sh
%rpmattr	%{_prefix}/lib/rpm/rpmdiff
%rpmattr	%{_prefix}/lib/rpm/rpmdeps
%rpmattr    	%{_prefix}/lib/rpm/pythondeps.sh

%{_mandir}/man8/rpmbuild.8*
%{_mandir}/man8/rpmdeps.8*

%if %buildpython
%files -n python-rpm
%defattr(-,root,root)
%{_libdir}/python*/site-packages/rpm
%endif

%files -n %librpmname
%defattr(-,root,root)
%{_libdir}/librpm.so.%{libmajor}*
%{_libdir}/librpmio.so.%{libmajor}*
%{_libdir}/librpmbuild.so.%{libmajor}*

%files -n %librpmnamedevel
%defattr(-,root,root)
%{_includedir}/rpm
%{_libdir}/librpm.la
%{_libdir}/librpm.so
%{_libdir}/librpmio.la
%{_libdir}/librpmio.so
%{_libdir}/librpmbuild.la
%{_libdir}/librpmbuild.so
%{_libdir}/pkgconfig/rpm.pc


%changelog
* Fri Oct 28 2016 adrianomorselli <adrianomorselli> 4.8.1-10uplos2016
- rebuild

* Thu Apr 28 2016 bb <bb> 4.8.1-10pclos2016
- update cflags to same as version 7

* Wed Apr 27 2016 bb <bb> 4.8.1-9pclos2016
- drop cpu optimization

* Mon Apr 18 2016 bb <bb. 4.8.1-8pclos2016
- add cve patches, drop crond crap

* Wed Oct 02 2013 pinoc <vogtpet at gmail.com> 4.8.1-7pclos2013
- fix compiler, cpu, arch settings for 32bit in /usr/lib/rpm/macros

* Mon Aug 19 2013 billybot <billybot> 4.8.1-6pclos2013
- update python 2.7

* Mon Sep 26 2011 Texstar <texstar at gmail.com> 4.8.1-5pclos2011
- add custom macro for patch fuzz=2 like it was before

* Fri Jun 10 2011 Texstar <texstar at gmail.com> 4.8.1-4pclos2011
- update

* Fri Jun 03 2011 Texstar <texstar at gmail.com> 4.8.1-3pclos2011
- rebuild

* Fri Jun 03 2011 Texstar <texstar at gmail.com> 4.8.1-2pclos2011
- rebuild

* Thu Jun 02 2011 Texstar <texstar at gmail.com> 4.8.1-1pclos2011
- update for pclinuxos 2011 release

